#include <QApplication>
#include <QMainWindow>
#include <QTimer>
#include <bgtu/computer_graphics_lab_work/renderer_api/color.hpp>
#include <bgtu/computer_graphics_lab_work/utilities/default_renderer_linear.hpp>
#include <bgtu/computer_graphics_lab_work/qt_utilities/renderer_widget.hpp>
#include <bgtu/computer_graphics_lab_work/qt_utilities/owned_qimage.hpp>

int main(int argc, char **argv) {

	QApplication qApplication{argc, argv};
//	qRegisterMetaType<BGTU::ComputerGraphicsLabWork::QtUtilities::OwnedQImage>("OwnedQImage");

	QTimer fps_timeout;
	unsigned frames = 0;
	fps_timeout.callOnTimeout([&] {
		qCritical() << (frames * 4) << "\n";
		qDebug() << (frames * 4) << "\n";
		frames = 0;
	});
	fps_timeout.setInterval(250);
	fps_timeout.start();
	QMainWindow w{};
	class o : public QObject {
	public:
		unsigned *frames;

		explicit o(unsigned *f) : QObject{}, frames{f} {}

	public slots:

		void hit() {
			(*this->frames)++;
		}
	};


	o oo{&frames};

	BGTU::ComputerGraphicsLabWork::QtUtilities::SeparateThreadedDefaultRendererLinear<void> renderer{};
	QObject::connect(&renderer, &BGTU::ComputerGraphicsLabWork::QtUtilities::_SeparateThreadedRenderer_Signals::frame_rendered, &oo, &o::hit);
	renderer.set_background(BGTU::ComputerGraphicsLabWork::RendererApi::Color{0, 0, 0});
	BGTU::ComputerGraphicsLabWork::QtUtilities::RendererWidget<void> canvas{&renderer, &w};
	w.setCentralWidget(&canvas);
	w.show();

	QApplication::exec();
}