#pragma once

#include <utility>
#include <Qt>
#include <QObject>
#include <QWidget>
#include <QMutex>
#include <QPainter>
#include <QBrush>
#include <QApplication>
#include <QPalette>
#include <QStyle>
#include <bgtu/computer_graphics_lab_work/utilities/default_renderer_linear.hpp>
#include "owned_qimage.hpp"
#include "separate_threaded_renderer.hpp"


namespace BGTU::ComputerGraphicsLabWork::QtUtilities {
	template<class sprite_data_t>
	class RendererWidget;

	class _RendererWidget_Slots : public QWidget {
		template<class>
		friend
		class RendererWidget;

	Q_OBJECT

	private:
		inline _RendererWidget_Slots(QWidget *owner) : QWidget{owner} {}

	private slots:

		virtual void receive_image(OwnedQImage *img) = 0;

	};
}